#######
# Calendar class v3.2
# Copyright (c) 2002 Alexander Egorov
# Author: Alexander Egorov <egr@yandex.ru> (http://www.egoroff.spb.ru/)
##
#    XML   ( ^xml[])
#  :    init
# $object[^calendar::init[$date_user]] 
#   XML  ^object.xml[]
#  :
# in -       
# f -     
# hit -     ->       
#     
@CLASS
calendar

#######
@init[date_user]
#   
$date_now[^date::now[]]

^if($date_user.year && $date_user.month){
	$d($date_user.day)
	$m($date_user.month)
	$y($date_user.year)
}{
	$d($date_now.day)
	$m($date_now.month)
	$y($date_now.year)
}

# .      
#    
$self.date_user[$date_user]

#        
# -  ,    , 
#          
#  @i18n[]
^i18n[]

#       .  
$calendar_month_prev[^date::create($y;$m)]
^calendar_month_prev.roll[month](-1)
$prev_m($calendar_month_prev.month)
$prev_y($calendar_month_prev.year)

#       .  
$calendar_month_next[^date::create($y;$m)]
^calendar_month_next.roll[month](+1)
$next_m($calendar_month_next.month)
$next_y($calendar_month_next.year)

# the hash of publications(files)
$days_of_files[
	^hash::sql{
		SELECT
			DAYOFMONTH(date_field),
			some_field
		FROM
			some_table
		WHERE
			MONTH(date_field) = $m and
			YEAR(date_field) = $y 
	}[$.distinct(1)]
]

#######
# ,       
#  
@i18n[]
# the hash of local calendar (month and day names)
$calendar_locale[ 
	$.month_names[ 
		$.1[]
		$.2[]
		$.3[]
		$.4[]
		$.5[]
		$.6[]
		$.7[]
		$.8[]
		$.9[]
		$.10[]
		$.11[]
		$.12[]
	]
	$.day_names[
		$.0[]
		$.1[]
		$.2[]
		$.3[]
		$.4[]
		$.5[]
		$.6[]
	]
]
$month[$calendar_locale.month_names.$m]
$calendar_month[^date:calendar[rus]($y;$m)] 

#######
@xml[]
$result[
	<month>
		^month_year[]
		^weekdays[]
		^week[]
	</month>
]

#######
#      
@month_year[][hit]
^if(
	$date_user.day ||
	(
		$date_now.month == $date_user.month && 
		$date_now.year == $date_user.year &&
		$date_user.day
	)
){
	$hit[]
}{
	$hit[hit="1"]
}

<month_year
	month="$m"
	month_title="$month"
	next_month="$next_m"
	prev_month="$prev_m"
	year="$y"
	next_year="$next_y"
	prev_year="$prev_y"
	$hit
/>

#######
#    
@weekdays[]
<weekdays>
^for[i](0;6){
	<day title="$calendar_locale.day_names.$i"/>
}
</weekdays>

#######
#      
# day -  ,   ,  /
# /      /
@week[][day;in;f;hit]
^calendar_month.menu{
	<week>
	^for[i](0;6){
		$day($calendar_month.$i)
#    
		^if(
			$date_now.day == $day &&
			$date_now.month == $date.month &&
			$date_now.year == $date.year
		){
			$in[in="1"]
		}{
			$in[]
		}
#      
		^if($day == $date.day){
			$hit[hit="1"]
		}{
			$hit[]
		}
#      
		^if($days_of_files.$day){
			$f[f="1"]
		}{
			$f[]
		}
		<day d="$day" $in $f $hit/>
	}
	</week>
}